/*
 * Created on 3 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.bonita;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import java.util.*;

import org.w3c.dom.Document;

/**
 * @author delfourr
 */
public class BonitaActivityExecutor {



	/**
	 * Default constructor
	 */
	public BonitaActivityExecutor() {
		
	}
	
	
	
	/**
	 * Allows to find, initialise and terminate an activity.
	 * @param document Document with the activity information (name, attributes and project name).
	 * @throws LoginException
	 */
	public void endActivity(Document document){
		
		//'parse' transforms a Document
		DocumentParser parse = new DocumentParser();

		DataActivity data = parse.parseActivity(document);
		
				
		//get the project name to wich it belongs	
		String projectName = data.getProjectName();


		//get the process name	
		String activityName = data.getProcessName();


		//get the process properties
		HashMap table = data.getProcessProperties();
		
		
		//terminate the activity thanks to its name and properties
		this.terminateActivity(activityName, projectName, table);		
	}
	
	
	
	
	
	/**
	 * Thanks to its name, the activity is found and stopped. 
	 * Before, its attributes are set with the HashMap values.
	 * @param activityName Name of the activity to stop.
	 * @param projectName Name of the project to which it belongs.
	 * @param table HashMap with the activity attributes associated to their values.
	 * @throws LoginException
	 */
	private void terminateActivity(String activityName, String projectName, HashMap table) {

		//The local home
		ProjectSessionHome projecth = null;

		//The bean
		ProjectSession project = null;

			try {
				//Getting local home by using JNDI
				projecth = ProjectSessionUtil.getHome();

				//Creation of the project
				project = projecth.create();
				
				project.initProject(projectName);
				

				//**************************************************************************
				//					SET THE ACTIVITY PROPERTIES
				//**************************************************************************

				//All the keys are saved in a set
				Set collec = table.keySet();

				//Set properties if they exist
				if (collec.size() > 0) {

					//For all the keys we have to retrieve the associated value
					Iterator it = collec.iterator();

					//variable which will stock the property name
					String cle="";

					while (it.hasNext()) {

						//Getting the values
						cle = (String) it.next();

						//Set the current process property
						project.setNodeProperty(activityName, cle, (String) table.get(cle));

					}
				}
				
				//The local home
				UserSessionHome userh = UserSessionUtil.getHome();

				//The bean
				UserSession user = userh.create();
				
				
				//the session terminates the activity
				user.terminateActivity( projectName, activityName);


			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}

}
