/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: Sample1RunningSession.java,v 1.3 Anne Geron Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

/* This class implements the third part of the Business Process example described in the 
*   "BONITA workflow cooperative System Users's Guide
* jack : Custumer 
* john : Custumer Service employee
*/


import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;

import java.util.*;

public class Sample1RunningSession {
	
	static public void main(String[] args) throws Exception{
	
	  String instNameOP = "Order Processing_instance1" ;
	  String instNameAO = "Accept Order_instance1" ;

// jackOrderProcessing  	  
	  // "jack" is logged
	  char[] passwordJack={'j','a','c','k'};
	  SimpleCallbackHandler handlerJack = new SimpleCallbackHandler("jack",passwordJack);
	  LoginContext lcJack = new LoginContext("TestClient", handlerJack);
	  lcJack.login();
	  
		  
	  // jack creates User Session Bean  (Activity running)
	  UserSessionHome uJackHome=UserSessionUtil.getHome();
	  UserSession uJackSession = uJackHome.create();
	  
	  // ProjectSessionBean needed (Activity properties setting )
	  ProjectSessionHome prjHome=ProjectSessionUtil.getHome();
	  ProjectSession prjSession = prjHome.create();
	  
	  
	  System.out.println("SessionBean created");
	 	  
	 // Verifying roles
	 try {
	  	prjSession.initProject(instNameOP) ;
	 } catch(Exception e){System.out.println("initProject : exception raised") ;} 
	  	
	 try {
	 Collection roleNames = prjSession.getUserRolesInProject("jack") ;
	 Iterator j = roleNames.iterator();
	 while (j.hasNext())
	 { 
	 	System.out.println("user jack : rle : "+ j.next());
	 }
	} catch(Exception e){System.out.println("getUserRolesInProject : exception raised : " + e) ;} 
	
	
	// Activity to be started :  
	String activityName = "Receive Order" ;
	
	// etat de l'activit avant lancement 
	int state = 0 ;
	  try {
	  	state = prjSession.getNodeState(activityName);
	  } catch(Exception e){System.out.println("getNodeState : exception raised") ;} 
  
	  System.out.println("Verification : Node State : " + state);
	
	   
	  try {
	  	uJackSession.startActivity(instNameOP,activityName);
	  	System.out.println("(Jack) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  
	   
	  try {
	  	state = prjSession.getNodeState(activityName);
	  } catch(Exception e){System.out.println("getNodeState : exception raised") ;} 
  
	  System.out.println("Verification : Node State : " + state);
	

	 // Now He has to set the Order Data : setting the values for the properties associated to this activities
	 try {
	 	prjSession.setNodeProperty(activityName,"customer_name","jack",false) ;
	 	prjSession.setNodeProperty(activityName,"product_name","tv",false) ;
	 	prjSession.setNodeProperty(activityName,"items","1",false) ;
	 } catch(Exception e){System.out.println("setNodeProperty : exception raised : "+ e) ;} // maybe it raises some exception
	 
	 System.out.println("properties set");
	 
	 try {
	 Collection Properties = prjSession.getNodeProperties(activityName) ;
	 Iterator k = Properties.iterator();
	 while (k.hasNext())
	 { 
	 	System.out.println("Activity  "+ activityName +" property : "+ k.next());
	 }
	} catch(Exception e){System.out.println("getNodeProperties : exception raised : " + e) ;} 
	
	  
	   try {
	  	uJackSession.terminateActivity(instNameOP,activityName);
	  	System.out.println("(Jack) Activity terminated : " + activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 

// johnStartAcceptOrder
	  // "john" is logged
	  char[] passwordJohn ={'j','o','h','n'};
	  SimpleCallbackHandler handlerJohn = new SimpleCallbackHandler("john",passwordJohn);
	  LoginContext lcJohn = new LoginContext("TestClient", handlerJohn);
	  lcJohn.login();
	  
	  		  
	  // john creates User Session Bean  (Activity running)
	  UserSessionHome uJohnHome=UserSessionUtil.getHome();
	  UserSession uJohnSession = uJohnHome.create();
	  
	  // Activity to be started :  
	activityName = "Accept Order_instance1" ;
	  
	try {
	  	uJohnSession.startActivity(instNameOP,activityName);
	  	System.out.println("(John) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  
// jackStartAskCustomer
	// Session bean already created
	  	  // Activity to be started :  
	activityName = "Ask Customer" ;
	  
	try {
	  	uJackSession.startActivity(instNameAO,activityName);
	  	System.out.println("(Jack) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  	  
	   try {
	  	uJackSession.terminateActivity(instNameAO,activityName);
	  	System.out.println("(Jack) Activity terminated : "+ activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 

//johnTermAcceptOrder
	// Session bean already created
	
	// John starts and terminates "Notify Sales"
	activityName = "Notify Sales" ;
	try {
	  	uJohnSession.startActivity(instNameAO,activityName);
	  	System.out.println("(John) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  	  
	 try {
	  	uJohnSession.terminateActivity(instNameAO,activityName);
	  	System.out.println("(John) Activity terminated : "+ activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 

	// John terminates "Accept Order"
	activityName = "Accept Order_instance1" ;
	try {
	  	uJohnSession.terminateActivity(instNameOP,activityName);
	  	System.out.println("(John) Activity terminated : "+ activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 


	}




}


