package hero.entity;
import hero.interfaces.Constants;
import hero.interfaces.BnEdgeValue;

import java.util.*;

public class OrEdgeState extends EdgeState {

	private static OrEdgeState nd;

	public OrEdgeState() {
	}

	public static OrEdgeState getInstance() {
		if (nd == null) {
			nd = new OrEdgeState();
		}
		return nd;
	}

	public int state(Collection edges) {
		Iterator i = edges.iterator();
		int result = Constants.Nd.EDGEINITIAL;
		boolean active = false;
		while (i.hasNext()) {
			BnEdgeValue edge = (BnEdgeValue) i.next();

			if (edge.getState() == Constants.Ed.ACTIVE) {
				result = Constants.Nd.ACTIVE;
				active = true;
				break;
			}
			if (edge.getState() == Constants.Ed.INITIAL) {
				result = Constants.Nd.EDGEINITIAL;
				active = true;
			}
			if ((edge.getState() == Constants.Ed.ANTICIPATING)) {
				result = Constants.Nd.ANTACTIVE;
				active = true;
				break;	
			}
			if ((edge.getState() == Constants.Ed.DEAD) && !active)
				result = Constants.Nd.CANCEL;
		}
		return result;

	}

}
